<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\PopenerimaanioService;
use App\Http\Services\ApplicationparameterService;
use App\Http\Validators\PopenerimaanioValidator;
/* use App\Http\Services\KapalService;
use App\Http\Services\LokasiitemService;
use App\Http\Services\UsersService; */
use App\Http\Services\PenerimaanbarangioService; 
use App\Http\Services\VoyagesService;

class PopenerimaanioController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $appParam;
    /* private $kapal;
    private $lokasiitem;
    private $users; */
    protected $penerimaanbarangio;
    private $voyage;

    /**
     * Popenerimaanio constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new PopenerimaanioService();
        $this->validator = new PopenerimaanioValidator();
        $this->appParam = new ApplicationparameterService();
        /* $this->kapal = new KapalService();
        $this->lokasiitem = new LokasiitemService();
        $this->users = new UsersService(); */
        $this->voyage = new VoyagesService();
        $this->penerimaanbarangio = new PenerimaanbarangioService();

    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->store($request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/popenerimaanio")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = [
            "ioNumber" => "No PO"
            , "date" => "Tanggal PO"
            , "status" => "Status"
            , "quantity" => "quantity"
        ];
        $this->data["criteria"] = [
            "ioNumber" => "No PO"
            , "date" => "Tanggal PO"
            , "status" => "Status"
            , "quantity" => "quantity"
        ];
        $this->data["ordering"] = [
            "ioNumber:asc" => "No Transaksi &uarr;"
            , "ioNumber:desc" => "No Transaksi &darr;"
            , "date:asc" => "Tanggal PO &uarr;"
            , "date:desc" => "Tanggal PO &darr;"
        ];
        $input = $request->all();
        $this->data["popenerimaanios"] = $this->baseService->paging($request);
        $this->data["voyages"] = $this->voyage->getVoyages($request);
        return view("modules.popenerimaanio.popenerimaanio_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {       
        $this->data["popenerimaanio"] = $this->baseService->show($id);
        return view("modules.popenerimaanio.popenerimaanio_edit", $this->data);
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/popenerimaanio")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {      
        return view("modules.popenerimaanio.popenerimaanio_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Request $request, $id)
    {        
        $this->data["popenerimaanio"] = $this->baseService->show($id);
        if($this->data["popenerimaanio"]) {
            $this->data["penerimaanbarangios"] = $this->penerimaanbarangio->showBasedOnIoNumber($request, $this->data["popenerimaanio"]);
            return view("modules.popenerimaanio.popenerimaanio_show", $this->data);
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }

    public function generateLotNumber() {
        $lotNumber = $this->appParam->generateLotNumber();
        echo json_encode($lotNumber);
    }


}